<?php
 
 
 

namespace Google\Protobuf\Internal;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBWire;
use Google\Protobuf\Internal\InputStream;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;






class MethodDescriptorProto extends \Google\Protobuf\Internal\Message
{
    


    protected $name = null;
    





    protected $input_type = null;
    


    protected $output_type = null;
    


    protected $options = null;
    




    protected $client_streaming = null;
    




    protected $server_streaming = null;

    

















    public function __construct($data = NULL) {
        \GPBMetadata\Google\Protobuf\Internal\Descriptor::initOnce();
        parent::__construct($data);
    }

    



    public function getName()
    {
        return isset($this->name) ? $this->name : '';
    }

    public function hasName()
    {
        return isset($this->name);
    }

    public function clearName()
    {
        unset($this->name);
    }

    




    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    






    public function getInputType()
    {
        return isset($this->input_type) ? $this->input_type : '';
    }

    public function hasInputType()
    {
        return isset($this->input_type);
    }

    public function clearInputType()
    {
        unset($this->input_type);
    }

    







    public function setInputType($var)
    {
        GPBUtil::checkString($var, True);
        $this->input_type = $var;

        return $this;
    }

    



    public function getOutputType()
    {
        return isset($this->output_type) ? $this->output_type : '';
    }

    public function hasOutputType()
    {
        return isset($this->output_type);
    }

    public function clearOutputType()
    {
        unset($this->output_type);
    }

    




    public function setOutputType($var)
    {
        GPBUtil::checkString($var, True);
        $this->output_type = $var;

        return $this;
    }

    



    public function getOptions()
    {
        return $this->options;
    }

    public function hasOptions()
    {
        return isset($this->options);
    }

    public function clearOptions()
    {
        unset($this->options);
    }

    




    public function setOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Internal\MethodOptions::class);
        $this->options = $var;

        return $this;
    }

    





    public function getClientStreaming()
    {
        return isset($this->client_streaming) ? $this->client_streaming : false;
    }

    public function hasClientStreaming()
    {
        return isset($this->client_streaming);
    }

    public function clearClientStreaming()
    {
        unset($this->client_streaming);
    }

    






    public function setClientStreaming($var)
    {
        GPBUtil::checkBool($var);
        $this->client_streaming = $var;

        return $this;
    }

    





    public function getServerStreaming()
    {
        return isset($this->server_streaming) ? $this->server_streaming : false;
    }

    public function hasServerStreaming()
    {
        return isset($this->server_streaming);
    }

    public function clearServerStreaming()
    {
        unset($this->server_streaming);
    }

    






    public function setServerStreaming($var)
    {
        GPBUtil::checkBool($var);
        $this->server_streaming = $var;

        return $this;
    }

}

